#include "lib/gba.h"
#include "res.h"

//---------------------------------------------------------------------------
typedef struct {
	u8*  pDat;
	u32  imgCx;
	u16  cx;
	u16  cy;

	u16* pSheet;
	u16  cnt;
} ST_FONT;

//---------------------------------------------------------------------------
void WaitForVsync(void)
{
	while (*(volatile u16*)0x4000006 >= 160) {};
	while (*(volatile u16*)0x4000006 <  160) {};
}
//---------------------------------------------------------------------------
void Mode3DrawSJISChr(ST_FONT* p, s32 sx, s32 sy, u16 chr, u16 col)
{
	u8* pDat = p->pDat;
	s32 i;

	for(i=0; i<p->cnt; i++)
	{
		if(chr == p->pSheet[i])
		{
			pDat += i * p->cx;
			break;
		}
	}

	u16* pScreen = (u16*)VRAM + (sy * 240) + sx;
	s32  x, y;

	for(y=0; y<p->cy; y++)
	{
		for(x=0; x<p->cx; x++)
		{
			if(pDat[y*p->imgCx + x] == 0x00)
			{
				continue;
			}

			pScreen[y*240 + x] = col;
		}
	}
}
//---------------------------------------------------------------------------
void Mode3DrawSJISStr(ST_FONT* p, s32 sx, s32 sy, char* str, u16 col)
{
	u16 chr;
	s32 i=0, x=0, y=0;

	for(;;)
	{
		chr = str[i] | (str[i+1] << 8);
		i += 2;

		if(chr == '\0')
		{
			return;
		}

		// s
		if(sx + x >= 240)
		{
			x  = 0;
			y += p->cy;

			if(sy + y + p->cy >= 160)
			{
				return;
			}
		}

		Mode3DrawSJISChr(p, sx + x, sy + y, chr, col);
		x += p->cx;
	}
}
//---------------------------------------------------------------------------
int main(void)
{
	SetMode(MODE_3 | BG2_ENABLE);

	ST_FONT f;

	f.pDat   = (u8*)&mplus_j10rBitmap;
	f.imgCx  = 69630 + 2;				// +2́Agrit̃TCY
	f.cx     = 10;
	f.cy     = 11;

	f.pSheet = (u16*)&mplus_jfnt_txt;
	f.cnt    = 6963;

	Mode3DrawSJISStr(&f, 16, 16, "L܂", RGB5(31,31,31));

	for(;;)
	{
	    WaitForVsync();
	}
}
