#include <stdlib.h>

#include "lib/gba.h"
#include "sintbl.h"
#include "res.h"

//---------------------------------------------------------------------------
void WaitForVsync(void)
{
	while (*(volatile u16*)0x4000006 >= 160) {};
	while (*(volatile u16*)0x4000006 <  160) {};
}
//---------------------------------------------------------------------------
//BG2̏cE̊g嗦%Ŏw
void RotateBG2(s32 angle)
{
	REG_BG2PA =  GetCos(angle);
	REG_BG2PB =  GetSin(angle);
	REG_BG2PC = -GetSin(angle);
	REG_BG2PD =  GetCos(angle);

	// bgx = x1 -  *  cos(-) * hzoom
	// bgy = y1 -  * -sin(-) * vzoom
	s32 bg2x = 120 * 256 - 144 *  GetCos(angle-33);
	s32 bg2y =  80 * 256 - 144 * -GetSin(angle-33);

	if(bg2x < 0)
	{
	 	REG_BG2X = 0xFFFFFFF - abs(bg2x);
	}
	else
	{
		REG_BG2X = abs(bg2x);
	}
	
	if(bg2y < 0)
	{
		REG_BG2Y = 0xFFFFFFF - abs(bg2y);
	}
	else
	{
		REG_BG2Y = abs(bg2y);
	}
}
//---------------------------------------------------------------------------
int main(void)
{
	// [hݒ
	SetMode(MODE_3 | BG2_ENABLE);

	// 摜̓ǂݍ
	REG_DMA3SAD = (u32)&imageBitmap;
	REG_DMA3DAD = (u32)VRAM;
	REG_DMA3CNT = (u32)(240*160) | (DMA_SRC_INC | DMA_DST_INC | DMA16 | DMA_ENABLE);

	s32 angle = 0;

	for(;;)
	{
		WaitForVsync();

		if(++angle >= 360)
		{
			angle = 0;
		}

		RotateBG2(angle);
	}
}
