#include "lib/gba.h"
#include "sintbl.h"
#include "res.h"

#define SHAKE_CYCLE		4				// h̎
#define SHAKE_CX		64				// U̕

//---------------------------------------------------------------------------
volatile s32 angle;						// h1̈ʒu


//---------------------------------------------------------------------------
void WaitForVsync(void)
{
	while (*(volatile u16*)0x4000006 >= 160) {};
	while (*(volatile u16*)0x4000006 <  160) {};
}
//---------------------------------------------------------------------------
void IrqHandler(void)
{
	REG_IME  = 0;
	u16 flag = REG_IF;
	REG_IF   = flag;

	if(flag & IRQ_HBLANK)
	{
		if(REG_VCOUNT < 160)
		{
			// h炷
			REG_BG0HOFS = GetSin(angle * SHAKE_CYCLE + REG_VCOUNT) * SHAKE_CX / 256;
		}
		else if(REG_VCOUNT == 227)
		{
			// ̃t[VCOUNT 0p
			REG_BG0HOFS = GetSin(angle * SHAKE_CYCLE + 0) * SHAKE_CX / 256;
		}
	}

	REG_IME = 1;
}
//---------------------------------------------------------------------------
void IrqSetup(void)
{
	REG_IME = 0;

	INT_VECTOR   = (u32)IrqHandler;
	REG_DISPSTAT = LCDC_HBL;
	REG_IE       = IRQ_HBLANK;

	REG_IME = 1;
}
//---------------------------------------------------------------------------
int main(void)
{
	// [hݒ
	SetMode(MODE_0 | BG0_ENABLE);
	REG_BG0CNT = (BG_SIZE_0 | BG_256_COLOR | CHAR_BASE(0) | MAP_BASE(28)); 

	u16* pal = BG_PALETTE;			// BGpbg
	u16* chr = CHAR_BASE_ADR(0);	// LN^f[^
	u16* map = MAP_BASE_ADR(28);	// }bvf[^

	u32 i;

	// pbgݒ
	for(i=0; i<256; i++)
	{
		pal[i] = imagePal[i];
	}

	// LN^i[
	for(i=0; i<(240*160)/2; i++)
	{
		chr[i] = imageTiles[i];
	}

	// }bvi[
	i = 0;
	u32 x, y;
	for(y=0; y<20; y++)
	{
		for(x=0; x<30; x++)
		{
			map[y*32+x] = i++;
		}
	}

	angle = 0;
	IrqSetup();

	for(;;)
	{
		WaitForVsync();

		if(++angle == (360 / SHAKE_CYCLE))
		{
			angle = 0;
		}
	}
}
